program DiskActivity;

{$mode objfpc}{$H+}

uses Windows;

{$R *.res}

const
  MyExitCode = 193;

var
  ActivityPeriod: Byte;
  Disk: Char;
  strParam: AnsiString;
  intErrCode: Integer;
  hFile: THandle;
  strFileName: AnsiString = 'X:\activity.txt';
  Buff: PByte = nil;
  RealWritten: DWORD = 0;
  strErrCode: AnsiString;
  SPC: DWORD = 0; BPS: DWORD = 0; NOFC: DWORD = 0; TNOFC: DWORD = 0;

begin
  try
    strParam := ParamStr(1);
    if (Length(strParam) = 0) then
    begin
      ExitCode := MyExitCode;
      Exit;
    end;
    Disk:=strParam[1];

    strParam := ParamStr(2);
    if (Length(strParam) = 0) then
    begin
      ExitCode := MyExitCode;
      Exit;
    end;
    Val(strParam, ActivityPeriod, intErrCode);
    if (intErrCode <> 0) then
    begin
      ExitCode := MyExitCode;
      Exit;
    end;

    if (ActivityPeriod < 1) then ActivityPeriod := 1
    else if (ActivityPeriod > 21) then ActivityPeriod := ActivityPeriod mod 20;

    strFileName[1]:=Disk;

    if (GetDiskFreeSpace(PChar(Disk+':\'), SPC, BPS, NOFC, TNOFC) = False) then
    begin
      ExitCode := GetLastError();
      Exit;
    end;

    hFile:=CreateFile(PChar(strFileName), GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE,
              nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL or FILE_ATTRIBUTE_HIDDEN or FILE_FLAG_NO_BUFFERING, 0);
    if (hFile = INVALID_HANDLE_VALUE) then
    begin
      ExitCode := GetLastError();
      Exit;
    end;

    Buff:=VirtualAlloc(nil, BPS, MEM_COMMIT, PAGE_READWRITE);
    if Buff = nil then
    begin
      ExitCode := GetLastError();
      Exit;
    end;

    while True do
    begin
      FillChar(Buff^, BPS, Chr(Random(256)));

      SetFilePointer(hFile, 0, nil, FILE_BEGIN);

      if (WriteFile(hFile, Buff^, BPS, RealWritten, nil) = False) then
      begin
        ExitCode := GetLastError();
        Exit;
      end;

      Sleep(ActivityPeriod * 1024);
    end;

    CloseHandle(hFile)

  finally
    if (ExitCode = 193) then
      MessageBox(0,
        'Start with this parameters: DiskActivity.exe L T'#13#10 +
        'where L it is Letter of Disk, and T it is Time in seconds'#13#10 +
        'T must in 1s - 20s',
        'How to use', 0)
    else if (ExitCode <> 0) then
    begin
      Str(ExitCode, strErrCode);
      MessageBox(0, PChar('Error occured!'#13#10 + 'Error number ' + strErrCode), 'Error!', 0);
    end;
  end;
end.

